unit rmndme1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, checklst, Buttons, ExtCtrls, MPlayer, GIFImage, Registry;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Label1: TLabel;
    CheckListBox2: TCheckListBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Image2: TImage;
    Label3: TLabel;
    CheckListBox1: TCheckListBox;
    GIFImage1: TGIFImage;
    procedure ReadSet(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure ChkAll(Sender: TObject);
    procedure ChkToday(Sender: TObject);
    procedure CheckListBox1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FullDate, MonthNDay: String;
    DatFile: String;
    SetCnfrm, SetAdv: String;
    SetDIA: Integer;
  end;

var
  Form1: TForm1;

implementation

uses rmndme2, rmndme3, rmndme4, rmndme5;

{$R *.DFM}

procedure TForm1.ReadSet(Sender: TObject);
var
   IniFile: TRegistry;
   Year1, Month1, Day1: Word;
   Year, Month, Day: String;
begin
     // Set the location of the REMINDME.DAT file.
     Form1.DatFile := (copy(application.exename,1,(length(application.exename)-3)) + 'DAT');

     // Open RemindMe Registry entry and read in settings.
     IniFile:= TRegistry.Create;
     IniFile.LazyWrite := False;
     try
        IniFile.OpenKey('Software\Remindme', True);
        if not IniFile.ValueExists('Confirm') then IniFile.WriteString('Confirm', 'True');
        if not IniFile.ValueExists('Advance') then IniFile.WriteString('Advance', 'False');
        if not IniFile.ValueExists('DIAdv') then IniFile.WriteInteger('DIAdv', 3);
        Form1.SetCnfrm := IniFile.ReadString('Confirm');
        Form1.SetAdv := IniFile.ReadString('Advance');
        Form1.SetDIA := IniFile.ReadInteger('DIAdv');
     finally
        IniFile.Free;
     end;

     // Set FullDate and MonthNDay strings for todays date.
     DecodeDate(Now, Year1, Month1, Day1);
     if Month1 < 10 then Month := '0' + IntToStr(Month1);
     if Month1 > 9 then Month := IntToStr(Month1);
     if Day1 < 10 then Day := '0' + IntToStr(Day1);
     if Day1 > 9 then Day := IntToStr(Day1);
     Year := IntToStr(Year1);
     MonthNDay := Month + '/' + Day;
     FullDate := Month + '/' + Day + '/' + Year;
end;

function GetFD(DateTC: TDateTime) : String;
var
   Year1, Month1, Day1: Word;
   Year, Month, Day: String;
begin
     DecodeDate(DateTC, Year1, Month1, Day1);
     if Month1 < 10 then Month := '0' + IntToStr(Month1);
     if Month1 > 9 then Month := IntToStr(Month1);
     if Day1 < 10 then Day := '0' + IntToStr(Day1);
     if Day1 > 9 then Day := IntToStr(Day1);
     Year := IntToStr(Year1);
     Result := Month + '/' + Day + '/' + Year;
end;

procedure TForm1.ChkAll(Sender: TObject);
var
   F1: TextFile;
   Ltc: String;
begin
if fileexists(Form1.DatFile) then
   begin
        // Open REMINDME.DAT and move to the first line.
        AssignFile(F1, Form1.DatFile);
        Reset(F1);
        // Clear List Boxes on All Reminders window.
        Form4.CheckListBox1.Items.Clear;
        Form4.CheckListBox2.Items.Clear;
        // Until EOF read from REMINDME.DAT and put items in CheckListBox1
        // and put item descriptions in CheckListBox2.
        while not eof(F1) do
        begin
             ReadLn(F1, Ltc);
             if Ltc <> '' then
             begin
                  Form4.CheckListBox1.Items.Add(copy(Ltc,1,(pos('',ltc)-2)));
                  Form4.CheckListBox2.Items.Add(copy(ltc,(pos('',ltc)+2),length(ltc)));
             end;
        end;
        CloseFile(F1);
        Form4.Label1.Caption := 'To view the description of an item, click once on the item.';
   end;
end;

procedure TForm1.ChkToday(Sender: TObject);
var
   Ltc: String;
   F1: TextFile;
   i: Integer;
   NumToday: Integer;
   CheckDate: String;
begin
   // Do ReadSet to read in config from registry.
   ReadSet(Form1);

   // Set main caption with todays date.
   label1.caption:='Reminders For Today:  ' + FullDate;

   // If there is no REMINDME.DAT file then set 0 reminders.
   if not FileExists(Form1.DatFile) then Label2.Caption := 'There are no reminders for today. To add a new reminder click the Add New Reminder button.';

   // If REMINDME.DAT exists, then open it and clear list boxes on Todays
   // Reminders window.
   if FileExists(Form1.DatFile) then
   begin
      // Open REMINDME.DAT
      AssignFile(F1, Form1.DatFile);
      NumToday := 0;
      Form1.CheckListBox1.Items.Clear;
      Form1.CheckListBox2.Items.Clear;
      // Start checking.
      if Form1.SetAdv = 'False' then Form1.SetDIA := 0;
      for i := 0 to SetDIA do
      begin
        // Setup date for advance reminders.
        CheckDate := GetFD( (StrToDate(FullDate) + i) );
        // Until EOF read a line and if the first 5 chars = the first 5 chars
        // from CheckDate, add it to the listboxes.
        Reset(F1);
        while not eof(F1) do
        begin
             Readln(F1, Ltc);
             if copy(Ltc, 1, 5) = copy(CheckDate, 1, 5) then
               begin
                if (copy(ltc, 7, 4) = '    ') or (copy(ltc, 7, 4) = copy(CheckDate, 7, 4)) then
                begin
                  CheckListBox1.Items.Add(copy(Ltc,12,(pos('',ltc)-12)));
                  CheckListBox2.Items.Add(copy(ltc,(pos('',ltc)+2),length(ltc)));
                  NumToday := NumToday + 1;
                end;
               end;
        end;
      end;
      // If no reminders were added to the listbox NumToday = 0.
      if NumToday = 0 then Label2.Caption := 'There are no reminders for today. To add a new reminder click the Add New Reminder button.';
      if NumToday > 0 then Label2.Caption := 'To view the description of an item, click once on the item.';
      closefile(f1);
   end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
     form2.showmodal;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
   F1, F2: TextFile;
   Tmp, ItmRemove, OldMnthDay, OldItmInf: String;
begin
   // Make sure it has the newest settings read in.
   Form1.ReadSet(Form1);
   
   // If no item is selected, tell the user to select one.
   if CheckListBox1.ItemIndex = -1 then ShowMessage('You must select an item first.');

   if CheckListBox1.ItemIndex > -1 then
   begin
        // If Confirm Delete is set in options, confirm.
        if (Form1.SetCnfrm = 'True') and
        (messagebox(0,'Are you sure you want to remove this item?', 'Confirm Delete', 4) = 6) or
        (Form1.SetCnfrm = 'False') then
        begin
             // Set the item to be removed and open REMINDME.DAT and TEMP.FIL.
             ItmRemove := CheckListBox1.Items.Strings[CheckListBox1.ItemIndex] + ' ' + CheckListBox2.Items.Strings[CheckListBox2.ItemIndex];
             AssignFile(F1, Form1.DatFile);
             AssignFile(F2, 'Temp.Fil');
             Reset(F1);
             ReWrite(F2);
             // Until EOF read a line from REMINDME.DAT, make sure it isn't the
             // item the user is removing, and write the line to TEMP.FIL.
             While Not EOF(F1) Do
             begin
                  ReadLn(F1, Tmp);
                  OldItmInf := copy(Tmp, 12, length(Tmp));
                  if OldItmInf <> ItmRemove then WriteLn(F2, Tmp);
             end;
             // Finish up. (Copy TEMP.FIL back to REMINDME.DAT since it does not
             // contain the line the user wanted to remove.
             closefile(F1);
             closefile(F2);
             DeleteFile(Form1.DatFile);
             CopyFile('TEMP.FIL', PChar(Form1.DatFile), False);
             DeleteFile('TEMP.FIL');
             // Reload Listbox
             Form1.ChkToday(Form1);
        end;
   end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
     Form4.ShowModal;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
     form5.showmodal;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
     form3.showmodal;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
close;
end;

procedure TForm1.CheckListBox1Click(Sender: TObject);
begin
CheckListBox2.ItemIndex:=CheckListBox1.ItemIndex;
Label2.Caption:=CheckListBox2.Items.Strings[CheckListBox2.ItemIndex];
end;

end.
